---
title: Create a Datasource Entry
description: Create a datasource entry in a specific datasource
url: https://storyblok.com/docs/api/management/datasource-entries/create-a-datasource-entry
---

# Create a Datasource Entry

POST

```html
https://mapi.storyblok.com/v1/spaces/:space_id/datasource_entries
```

Create a datasource entry in a specific datasource.

## Path parameters

-   `:space_id` (required) (number)
    
    Numeric ID of a space
    

## Request body properties

-   `datasource_entry` (The Datasource Entry Object)
    
    The [datasource entry object](/docs/api/management/datasource-entries/the-datasource-entry-object)
    
    Show child properties
    
    -   `name` (required) (string)
        
        The `key` of a datasource entry
        
    -   `value` (required) (string)
        
        The `value` of a datasource entry
        
    -   `datasource_id` (number)
        
        Numeric ID of the datasource
        
    

## Response properties

-   `datasource_entry` (The Datasource Entry Object)
    
    The [datasource entry object](/docs/api/management/datasource-entries/the-datasource-entry-object)
    

## Examples

Create a datasource entry in a specific datasource and position it at the beginning of the datasource.

-   cURL
    
    ```shellscript
    curl "https://mapi.storyblok.com/v1/spaces/288868932106293/datasource_entries" \
      -X POST \
      -H "Authorization: YOUR_OAUTH_TOKEN" \
      -H "Content-Type: application/json" \
      -d "{\"datasource_entry\":{\"datasource_id\":12345,\"name\":\"newsletter_text\",\"position\":1,\"value\":\"Subscribe to our newsletter.\"}}"
    ```
    
-   JS
    
    ```javascript
    // storyblok-js-client@>=7, node@>=18
    import Storyblok from "storyblok-js-client";
    
    const storyblok = new Storyblok({
      oauthToken: "YOUR_PERSONAL_ACCESS_TOKEN",
    });
    
    try {
      const response = await storyblok.post('spaces/288868932106293/datasource_entries', {
        "datasource_entry": {
          "datasource_id": 12345,
          "name": "newsletter_text",
          "position": 1,
          "value": "Subscribe to our newsletter."
        }
      })
      console.log({ response })
    } catch (error) {
      console.log(error)
    }
    ```
    
-   PHP
    
    ```php
    $client = new \Storyblok\ManagementClient('YOUR_OAUTH_TOKEN');
    
    $payload = ["datasource_entry" => ["datasource_id" => 12345,"name" => "newsletter_text","position" => 1,"value" => "Subscribe to our newsletter."]];
    
    $client->post('spaces/288868932106293/datasource_entries', $payload)->getBody();
    ```
    
-   Java
    
    ```java
    HttpResponse<String> response = Unirest.post("https://mapi.storyblok.com/v1/spaces/288868932106293/datasource_entries")
      .header("Content-Type", "application/json")
      .header("Authorization", "YOUR_OAUTH_TOKEN")
      .body({"datasource_entry":{"datasource_id":12345,"name":"newsletter_text","position":1,"value":"Subscribe to our newsletter."}})
      .asString();
    ```
    
-   C#
    
    ```csharp
    var client = new RestClient("https://mapi.storyblok.com/v1/spaces/288868932106293/datasource_entries");
    var request = new RestRequest(Method.POST);
    
    request.AddHeader("Content-Type", "application/json");
    request.AddHeader("Authorization", "YOUR_OAUTH_TOKEN");
    request.AddParameter("application/json", "{\"datasource_entry\":{\"datasource_id\":12345,\"name\":\"newsletter_text\",\"position\":1,\"value\":\"Subscribe to our newsletter.\"}}", ParameterType.RequestBody);
    IRestResponse response = client.Execute(request);
    ```
    
-   Python
    
    ```python
    import requests
    
    url = "https://mapi.storyblok.com/v1/spaces/288868932106293/datasource_entries"
    
    querystring = {}
    
    payload = {"datasource_entry":{"datasource_id":12345,"name":"newsletter_text","position":1,"value":"Subscribe to our newsletter."}}
    headers = {
      'Content-Type': "application/json",
      'Authorization': "YOUR_OAUTH_TOKEN"
    }
    
    response = requests.request("POST", url, data=payload, headers=headers, params=querystring)
    
    print(response.text)
    ```
    
-   Ruby
    
    ```ruby
    require 'storyblok'
    client = Storyblok::Client.new(oauth_token: 'YOUR_OAUTH_TOKEN')
    
    payload = {"datasource_entry" => {"datasource_id" => 12345,"name" => "newsletter_text","position" => 1,"value" => "Subscribe to our newsletter."}}
    
    client.post('spaces/288868932106293/datasource_entries', payload)
    ```
    
-   Swift
    
    ```swift
    let storyblok = URLSession(storyblok: .mapi(accessToken: .oauth("YOUR_OAUTH_TOKEN")))
    var request = URLRequest(storyblok: storyblok, path: "spaces/288868932106293/datasource_entries")
    request.httpMethod = "POST"
    request.httpBody = try JSONSerialization.data(withJSONObject: [
        "datasource_entry": [
            "datasource_id": 12345,
            "name": "newsletter_text",
            "position": 1,
            "value": "Subscribe to our newsletter.",
        ],
    ])
    let (data, _) = try await storyblok.data(for: request)
    print(try JSONSerialization.jsonObject(with: data))
    ```
    
-   Kotlin
    
    ```kotlin
    val client = HttpClient {
        install(Storyblok(MAPI)) {
            accessToken = OAuth("YOUR_OAUTH_TOKEN")
        }
    }
    
    val response = client.post("spaces/288868932106293/datasource_entries") {
        setBody(buildJsonObject {
            putJsonObject("datasource_entry") {
                put("datasource_id", 12345)
                put("name", "newsletter_text")
                put("position", 1)
                put("value", "Subscribe to our newsletter.")
            }
        })
    }
    
    println(response.body<JsonElement>())
    ```

## Pagination

-   [Previous: Datasource Entries](/docs/api/management/datasource-entries)
-   [Next: Delete a Datasource Entry](/docs/api/management/datasource-entries/delete-a-datasource-entry)
